Package org.apache.sysds.runtime.compress.colgroup

## Class ColGroupRLE

- java.lang.Object
- - org.apache.sysds.runtime.compress.colgroup.AColGroup
  - - org.apache.sysds.runtime.compress.colgroup.AColGroupCompressed
    - - org.apache.sysds.runtime.compress.colgroup.ADictBasedColGroup
      - - org.apache.sysds.runtime.compress.colgroup.AColGroupValue
        - - org.apache.sysds.runtime.compress.colgroup.APreAgg
          - - org.apache.sysds.runtime.compress.colgroup.AColGroupOffset
            - - org.apache.sysds.runtime.compress.colgroup.ColGroupRLE

All Implemented Interfaces:
  `Serializable`

    public class ColGroupRLE
    extends AColGroupOffset

A group of columns compressed with a single run-length encoded bitmap.

See Also:
  Serialized Form

### Nested Class Summary

### Nested classes/interfaces inherited from class org.apache.sysds.runtime.compress.colgroup.AColGroup

`AColGroup.CompressionType`

### Method Summary

All Methods Static Methods Instance Methods Concrete Methods
`AColGroup` `append​(AColGroup g)` Append the other column group to this column group.
`AColGroup` `appendNInternal​(AColGroup[] g)`
`AColGroup` `binaryRowOpLeft​(BinaryOperator op, double[] v, boolean isRowSafe)` Perform a binary row operation.
`AColGroup` `binaryRowOpRight​(BinaryOperator op, double[] v, boolean isRowSafe)` Perform a binary row operation.
`boolean[]` `computeZeroIndicatorVector()`
`boolean` `containsValue​(double pattern)` Detect if the column group contains a specific value.
`static char[]` `genRLEBitmap​(int[] offsets, int len)` Encodes the bitmap as a series of run lengths and offsets.
`org.apache.sysds.runtime.compress.colgroup.AColGroup.ColGroupType` `getColGroupType()`
`ICLAScheme` `getCompressionScheme()` Get the compression scheme for this column group to enable compression of other data.
`AColGroup.CompressionType` `getCompType()` Obtain the compression type.
`double` `getCost​(ComputationCostEstimator e, int nRows)` Get the computation cost associated with this column group.
`int[]` `getCounts​(int[] counts)`
`double` `getIdx​(int r, int colIdx)` Get the value at a colGroup specific row/column index position.
`void` `leftMultByMatrixNoPreAgg​(MatrixBlock matrix, MatrixBlock result, int rl, int ru, int cl, int cu)` Left multiply with this column group.
`void` `preAggregateDense​(MatrixBlock m, double[] preAgg, int rl, int ru, int cl, int cu)` Pre aggregate a dense matrix block into a pre aggregate target (first step of left matrix multiplication)
`void` `preAggregateSparse​(SparseBlock sb, double[] preAgg, int rl, int ru)`
`static ColGroupRLE` `read​(DataInput in, int nRows)`
`AColGroup` `scalarOperation​(ScalarOperator op)` Perform the specified scalar operation directly on the compressed column group, without decompressing individual cells if possible.
`AColGroup` `sliceRows​(int rl, int ru)` Slice range of rows out of the column group and return a new column group only containing the row segment.
`String` `toString()`
`AColGroup` `unaryOperation​(UnaryOperator op)` Perform unary operation on the column group and return a new column group

### Methods inherited from class org.apache.sysds.runtime.compress.colgroup.AColGroupOffset

`containZerosTuples, estimateInMemorySize, getExactSizeOnDisk, readData, readPointers, write`

### Methods inherited from class org.apache.sysds.runtime.compress.colgroup.APreAgg

`getPreAggregateSize, leftMultByAColGroup, mmWithDictionary, preAggregate, preAggregateThatIndexStructure, tsmmAColGroup`

### Methods inherited from class org.apache.sysds.runtime.compress.colgroup.AColGroupValue

`centralMoment, computeColSums, getCounts, getNumberNonZeros, getNumValues, replace, rexpandCols`

### Methods inherited from class org.apache.sysds.runtime.compress.colgroup.ADictBasedColGroup

`decompressToDenseBlock, decompressToSparseBlock, getDictionary, rightMultByMatrix`

### Methods inherited from class org.apache.sysds.runtime.compress.colgroup.AColGroupCompressed

`getMax, getMin, getSum, isEmpty, preAggRows, tsmm, unaryAggregateOperations, unaryAggregateOperations`

### Methods inherited from class org.apache.sysds.runtime.compress.colgroup.AColGroup

`appendN, colSum, decompressToDenseBlock, decompressToSparseBlock, get, getColIndices, getNumCols, rightMultByMatrix, shiftColIndices, sliceColumn, sliceColumns`

### Methods inherited from class java.lang.Object

`equals, getClass, hashCode, notify, notifyAll, wait, wait, wait`

### Method Detail

#### getCompType

    public AColGroup.CompressionType getCompType()

Description copied from class: `AColGroup`
Obtain the compression type.

Specified by:
  `getCompType` in class `AColGroup`
Returns:
  How the elements of the column group are compressed.

#### getColGroupType

    public org.apache.sysds.runtime.compress.colgroup.AColGroup.ColGroupType getColGroupType()

#### getCounts

    public int[] getCounts​(int[] counts)

#### scalarOperation

    public AColGroup scalarOperation​(ScalarOperator op)

Description copied from class: `AColGroup`
Perform the specified scalar operation directly on the compressed column group, without decompressing individual cells if possible.

Specified by:
  `scalarOperation` in class `AColGroup`
Parameters:
  `op` - operation to perform
Returns:
  version of this column group with the operation applied

#### unaryOperation

    public AColGroup unaryOperation​(UnaryOperator op)

Description copied from class: `AColGroup`
Perform unary operation on the column group and return a new column group

Specified by:
  `unaryOperation` in class `AColGroup`
Parameters:
  `op` - The operation to perform
Returns:
  The new column group

#### binaryRowOpLeft

    public AColGroup binaryRowOpLeft​(BinaryOperator op,
                                     double[] v,
                                     boolean isRowSafe)

Description copied from class: `AColGroup`
Perform a binary row operation.

Specified by:
  `binaryRowOpLeft` in class `AColGroup`
Parameters:
  `op` - The operation to execute
  `v` - The vector of values to apply, should be same length as dictionary length.
  `isRowSafe` - True if the binary op is applied to an entire zero row and all results are zero
Returns:
  A updated column group with the new values.

#### binaryRowOpRight

    public AColGroup binaryRowOpRight​(BinaryOperator op,
                                      double[] v,
                                      boolean isRowSafe)

Description copied from class: `AColGroup`
Perform a binary row operation.

Specified by:
  `binaryRowOpRight` in class `AColGroup`
Parameters:
  `op` - The operation to execute
  `v` - The vector of values to apply, should be same length as dictionary length.
  `isRowSafe` - True if the binary op is applied to an entire zero row and all results are zero
Returns:
  A updated column group with the new values.

#### computeZeroIndicatorVector

    public boolean[] computeZeroIndicatorVector()

#### getIdx

    public double getIdx​(int r,
                         int colIdx)

Description copied from class: `AColGroup`
Get the value at a colGroup specific row/column index position.

Specified by:
  `getIdx` in class `AColGroup`
Parameters:
  `r` - row
  `colIdx` - column index in the _colIndexes.
Returns:
  value at the row/column index position

#### leftMultByMatrixNoPreAgg

    public void leftMultByMatrixNoPreAgg​(MatrixBlock matrix,
                                         MatrixBlock result,
                                         int rl,
                                         int ru,
                                         int cl,
                                         int cu)

Description copied from class: `AColGroup`
Left multiply with this column group.

Specified by:
  `leftMultByMatrixNoPreAgg` in class `AColGroup`
Parameters:
  `matrix` - The matrix to multiply with on the left
  `result` - The result to output the values into, always dense for the purpose of the column groups parallelizing
  `rl` - The row to begin the multiplication from on the lhs matrix
  `ru` - The row to end the multiplication at on the lhs matrix
  `cl` - The column to begin the multiplication from on the lhs matrix
  `cu` - The column to end the multiplication at on the lhs matrix

#### containsValue

    public boolean containsValue​(double pattern)

Description copied from class: `AColGroup`
Detect if the column group contains a specific value.

Specified by:
  `containsValue` in class `AColGroup`
Parameters:
  `pattern` - The value to look for.
Returns:
  boolean saying true if the value is contained.

#### preAggregateDense

    public void preAggregateDense​(MatrixBlock m,
                                  double[] preAgg,
                                  int rl,
                                  int ru,
                                  int cl,
                                  int cu)

Description copied from class: `APreAgg`
Pre aggregate a dense matrix block into a pre aggregate target (first step of left matrix multiplication)

Specified by:
  `preAggregateDense` in class `APreAgg`
Parameters:
  `m` - The matrix to preAggregate
  `preAgg` - The preAggregate target
  `rl` - Row lower on the left side matrix
  `ru` - Row upper on the left side matrix
  `cl` - Column lower on the left side matrix (or row lower in the column group)
  `cu` - Column upper on the left side matrix (or row upper in the column group)

#### preAggregateSparse

    public void preAggregateSparse​(SparseBlock sb,
                                   double[] preAgg,
                                   int rl,
                                   int ru)

Specified by:
  `preAggregateSparse` in class `APreAgg`

#### getCost

    public double getCost​(ComputationCostEstimator e,
                          int nRows)

Description copied from class: `AColGroup`
Get the computation cost associated with this column group.

Specified by:
  `getCost` in class `AColGroup`
Parameters:
  `e` - The computation cost estimator
  `nRows` - the number of rows in the column group
Returns:
  The cost of this column group

#### read

    public static ColGroupRLE read​(DataInput in,
                                   int nRows)
                            throws IOException

Throws:
  `IOException`

#### sliceRows

    public AColGroup sliceRows​(int rl,
                               int ru)

Description copied from class: `AColGroup`
Slice range of rows out of the column group and return a new column group only containing the row segment. Note that this slice should maintain pointers back to the original dictionaries and only modify index structures.

Specified by:
  `sliceRows` in class `AColGroup`
Parameters:
  `rl` - The row to start at
  `ru` - The row to end at (not included)
Returns:
  A new column group containing the specified row range.

#### append

    public AColGroup append​(AColGroup g)

Description copied from class: `AColGroup`
Append the other column group to this column group. This method tries to combine them to return a new column group containing both. In some cases it is possible in reasonable time, in others it is not. The result is first this column group followed by the other column group in higher row values. If it is not possible or very inefficient null is returned.

Specified by:
  `append` in class `AColGroup`
Parameters:
  `g` - The other column group
Returns:
  A combined column group or null

#### appendNInternal

    public AColGroup appendNInternal​(AColGroup[] g)

#### getCompressionScheme

    public ICLAScheme getCompressionScheme()

Description copied from class: `AColGroup`
Get the compression scheme for this column group to enable compression of other data.

Specified by:
  `getCompressionScheme` in class `AColGroup`
Returns:
  The compression scheme of this column group

#### toString

    public String toString()

Overrides:
  `toString` in class `AColGroupValue`

#### genRLEBitmap

    public static char[] genRLEBitmap​(int[] offsets,
                                      int len)

Encodes the bitmap as a series of run lengths and offsets. Note that this method should not be called if the len is 0.

Parameters:
  `offsets` - uncompressed offset list
  `len` - logical length of the given offset list
Returns:
  compressed version of said bitmap